<?php

if (!defined('IN_AJAX')) die(basename(__FILE__));

global $bb_cfg, $lang, $userdata, $datastore;

$mode = (string) $this->request['mode'];
$user_id = (int) $this->request['user_id'];	
$html = '';

if(!$bb_cfg['friends']) $this->ajax_die($lang['MODULE_OFF']);
if(!$user_id) $this->ajax_die($lang['NO_SUCH_USER']);

switch($mode)
{	
	case 'list':
		$sql = DB()->fetch_rowset("SELECT uf.*, u.username, u.user_id, u.user_rank, u.user_opt, u.avatar_ext_id, u.user_posts
		    FROM bb_friends uf, ". BB_USERS ." u 
			WHERE uf.user_id = $user_id 
			    AND uf.friends_id = u.user_id
			ORDER BY u.username ASC");
		$count = DB()->fetch_row("SELECT COUNT(friends_id) AS friends FROM bb_friends WHERE user_id = $user_id");
		
		$ranks = $datastore->get('ranks');
		$datastore->enqueue(array(
			'ranks',
		));
        
		$html = '<div class="xenOverlay" style="z-index: 1000; top: 91.1px; left: 286.5px; display: block; position: fixed"><div class="section">';
        $html .= '<h2 class="heading h1">Список друзей пользователя '. get_username($user_id) .'</h2><div>';
		$html .= '<dl class="subHeading pairsInline"><dt>Найдено друзей: </dt><dd>'. $count['friends'] .'</dd></dl>';		
		$html .= (!$sql) ? '<ol class="overlayScroll"><li class="primaryContent memberListItem"><div class="member"><div class="userInfo"><div class="userBlurb dimmed"><span class="userTitle">У '. get_username($user_id) .' еще нет друзей</span></div></div></div></li></ol>' : '';

		foreach($sql as $row)
		{
			$my_friends = DB()->fetch_row("SELECT * FROM bb_friends WHERE user_id = ". $userdata['user_id'] ." AND friends_id = ". $row['user_id']);	
			$user_rank  = $row['user_rank'];
			$rank_title = isset($ranks[$user_rank]) ? $ranks[$user_rank]['rank_title'] : $lang['USER'];
			$rank_style = isset($ranks[$user_rank]) ? $ranks[$user_rank]['rank_style'] : '';
			
			$html .= '<ol class="overlayScroll" id="fr_'.$row['friends_id'].'"><li class="primaryContent memberListItem"><a href="'. PROFILE_URL . $row['user_id'] .'" class="avatars" alt="">'. str_replace('<img', '<img align="left"', get_avatar($row['user_id'], $row['avatar_ext_id'], !bf($row['user_opt'], 'user_opt', 'dis_avatar'), 50, 50)) .'</a>';
            $html .= '<div class="extra"><abbr class="DateTime">';
			$html .= ($user_id == $userdata['user_id']) ? '<a href="#" onclick="ajax.exec({action : \'friends\', mode: \'del\', user_id : \''.$row['user_id'] .'\'}); $(\'#fr_\'+ '.$row['friends_id'].').hide(\'slow\'); return false;" title="Удалить из списка друзей" ><img src="styles/images/delfrends.png"></a>' : '';
			$html .= (!$my_friends && $row['user_id'] != $userdata['user_id']) ? '<a href="#" onclick="ajax.exec({action : \'friends\', mode: \'add\', user_id : \''. $row['user_id'] .'\'}); return false;" title="Добавить в список друзей" ><img src="styles/images/addfrends.png"></a>' : '';
			$html .= '</abbr></div>';
            $html .= '<div class="member"><h3 class="username"><a href="'. PROFILE_URL.$row['user_id'] .'" class="username">'. profile_url($row) .'</a></h3>';
            $html .= '<div class="userInfo">';
            $html .= '<div class="userBlurb dimmed"><span class="'. $rank_style .'">'. $rank_title .'</span></div>';
            $html .= '<dl class="userStats pairsInline"><dt title="Всего сообщений, опубликованных '. $row['username'] .'">Сообщений: </dt><dd>'. $row['user_posts'] .'</dd></dl></div></div></li></ol>';
		}
		
		$html .= '</div><div class="sectionFooter overlayOnly"><a href="#" class="button primary OverlayCloser" onclick="$(\'.xenOverlay\').hide(\'slow\'); return false;" title="Закрыть список" ><img src="styles/images/closefrends.png"></a></a></div></div></div>';

	break;
	
	case 'add':
		$sql = DB()->fetch_row("SELECT * FROM bb_friends WHERE user_id = ". $userdata['user_id']." AND friends_id = $user_id");
		if($sql) $this->ajax_die(get_username($user_id) .' уже добавлен в список Ваших друзей');	
		if($userdata['user_id'] == $user_id) $this->ajax_die('Вы не можете добавить себя в свой список друзей!');
		
		DB()->query("INSERT INTO bb_friends (user_id, friends_id) VALUES (". $userdata['user_id'].", $user_id)");
		
		$message = 'Здравствуйте, [b]'. get_username($user_id) .'[/b].[br][br]
		    [b]'. $userdata['username'] .'[/b] добавил Вас в список своих друзей. [br][br]
			Для подтверждения ваших дружеских отношений, перейдите в профиль [b][url='. make_url(PROFILE_URL . $userdata['user_id']) .']'. $userdata['username'] .'[/url][/b] и добавьте его в список своих друзей.[br][br]
            [align=right][color=gray]Это автоматическое сообщение! Вам не нужно на него отвечать![/color][/align]';
        $subject = $userdata['username'] .' добавил Вас в список друзей';
		
		send_pm($user_id, $subject, $message, BOT_UID);
		cache_rm_user_sessions ($user_id);
		
		$html = $this->ajax_die(get_username($user_id) .' добавлен в список ваших друзей');
	break;
	
	case 'del':
		$sql = DB()->fetch_row("SELECT * FROM bb_friends WHERE user_id = ". $userdata['user_id']." AND friends_id = $user_id");
		if(!$sql) $this->ajax_die($lang['NO_SUCH_USER']);
		if($userdata['user_id'] == $user_id) $this->ajax_die('Вы не можете удалить себя из списка друзей!');
		
		DB()->query("DELETE FROM bb_friends WHERE user_id = ". $userdata['user_id']." AND friends_id = $user_id");
		
		$message = 'Здравствуйте, [b]'. get_username($user_id) .'[/b].[br][br]
		    [b][url='. make_url(PROFILE_URL . $userdata['user_id']) .']'. $userdata['username'] .'[/url][/b] удалил Вас в списка своих друзей. [br][br]
            [align=right][color=gray]Это автоматическое сообщение! Вам не нужно на него отвечать![/color][/align]';
        $subject = $userdata['username'] .' удалил Вас в списка друзей';
		
		send_pm($user_id, $subject, $message, BOT_UID);
		cache_rm_user_sessions ($user_id);
		
		$html = $this->ajax_die(get_username($user_id) .' удален из списка ваших друзей');
	break;
}

$this->response['html']	= $html;
$this->response['mode']	= $mode;